# Class PredicatedBag<E>

java.lang.Object
org.apache.commons.collections4.collection.AbstractCollectionDecorator<E>
org.apache.commons.collections4.collection.PredicatedCollection<E>
org.apache.commons.collections4.bag.PredicatedBag<E>

Type Parameters:
  `E` - the type of elements in this bag

All Implemented Interfaces:
  `Serializable`, `Iterable<E>`, `Collection<E>`, `Bag<E>`

Direct Known Subclasses:
  `PredicatedSortedBag`

public class PredicatedBag<E> extends PredicatedCollection<E> implements Bag<E>
Decorates another `Bag` to validate that additions match a specified predicate.

This bag exists to provide validation for the decorated bag. It is normally created to decorate an empty bag. If an object cannot be added to the bag, an `IllegalArgumentException` is thrown.

One usage would be to ensure that no null entries are added to the bag.

     Bag bag = PredicatedBag.predicatedBag(new HashBag(), NotNullPredicate.INSTANCE);

This class is Serializable from Commons Collections 3.1.

Since:
  3.0
See Also:
  - Serialized Form

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from class org.apache.commons.collections4.collection.PredicatedCollection

  `PredicatedCollection.Builder<E>`

- ## Field Summary

  ### Fields inherited from class org.apache.commons.collections4.collection.PredicatedCollection

  `predicate`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `PredicatedBag(Bag<E> bag, Predicate<? super E> predicate)`
  Constructor that wraps (not copies).

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `add(E object, int count)`
  Adds `nCopies` copies of the specified object to the Bag.
  `protected Bag<E>`
  `decorated()`
  Gets the decorated bag.
  `boolean`
  `equals(Object object)`
  `int`
  `getCount(Object object)`
  Gets the number of occurrences (cardinality) of the given object currently in the bag.
  `int`
  `hashCode()`
  `static <E> PredicatedBag<E>`
  `predicatedBag(Bag<E> bag, Predicate<? super E> predicate)`
  Factory method to create a predicated (validating) bag.
  `boolean`
  `remove(Object object, int count)`
  Removes `nCopies` copies of the specified object from the Bag.
  `Set<E>`
  `uniqueSet()`
  Returns a `Set` of unique elements in the Bag.

  ### Methods inherited from class org.apache.commons.collections4.collection.PredicatedCollection

  `add, addAll, builder, notNullBuilder, predicatedCollection, validate`

  ### Methods inherited from class org.apache.commons.collections4.collection.AbstractCollectionDecorator

  `clear, contains, containsAll, isEmpty, iterator, remove, removeAll, removeIf, retainAll, setCollection, size, toArray, toArray, toString`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface org.apache.commons.collections4.Bag

  `add, containsAll, iterator, remove, removeAll, retainAll, size`

  ### Methods inherited from interface java.util.Collection

  `addAll, clear, contains, isEmpty, parallelStream, removeIf, spliterator, stream, toArray, toArray`

  ### Methods inherited from interface java.lang.Iterable

  `forEach`

- ## Constructor Details

  - ### PredicatedBag

    protected PredicatedBag(Bag<E> bag, Predicate<? super E> predicate)
    Constructor that wraps (not copies).

    If there are any elements already in the bag being decorated, they are validated.

    Parameters:
      `bag` - the bag to decorate, must not be null
      `predicate` - the predicate to use for validation, must not be null
    Throws:
      `NullPointerException` - if bag or predicate is null
      `IllegalArgumentException` - if the bag contains invalid elements

- ## Method Details

  - ### predicatedBag

    public static <E> PredicatedBag<E> predicatedBag(Bag<E> bag, Predicate<? super E> predicate)
    Factory method to create a predicated (validating) bag.

    If there are any elements already in the bag being decorated, they are validated.

    Type Parameters:
      `E` - the type of the elements in the bag
    Parameters:
      `bag` - the bag to decorate, must not be null
      `predicate` - the predicate to use for validation, must not be null
    Returns:
      a new predicated Bag
    Throws:
      `NullPointerException` - if bag or predicate is null
      `IllegalArgumentException` - if the bag contains invalid elements
    Since:
      4.0

  - ### add

    public boolean add(E object, int count)
    Description copied from interface: `Bag`
    Adds `nCopies` copies of the specified object to the Bag.

    If the object is already in the `Bag.uniqueSet()` then increment its count as reported by `Bag.getCount(Object)`. Otherwise add it to the `Bag.uniqueSet()` and report its count as `nCopies`.

    Specified by:
      `add` in interface `Bag<E>`
    Parameters:
      `object` - the object to add
      `count` - the number of copies to add
    Returns:
      `true` if the object was not already in the `uniqueSet`

  - ### decorated

    protected Bag<E> decorated()
    Gets the decorated bag.
    Overrides:
      `decorated` in class `AbstractCollectionDecorator<E>`
    Returns:
      the decorated bag

  - ### equals

    public boolean equals(Object object)
    Specified by:
      `equals` in interface `Collection<E>`
    Overrides:
      `equals` in class `Object`

  - ### getCount

    public int getCount(Object object)
    Description copied from interface: `Bag`
    Gets the number of occurrences (cardinality) of the given object currently in the bag. If the object does not exist in the bag, return 0.
    Specified by:
      `getCount` in interface `Bag<E>`
    Parameters:
      `object` - the object to search for
    Returns:
      the number of occurrences of the object, zero if not found

  - ### hashCode

    public int hashCode()
    Specified by:
      `hashCode` in interface `Collection<E>`
    Overrides:
      `hashCode` in class `Object`

  - ### remove

    public boolean remove(Object object, int count)
    Description copied from interface: `Bag`
    Removes `nCopies` copies of the specified object from the Bag.

    If the number of copies to remove is greater than the actual number of copies in the Bag, no error is thrown.

    Specified by:
      `remove` in interface `Bag<E>`
    Parameters:
      `object` - the object to remove
      `count` - the number of copies to remove
    Returns:
      `true` if this call changed the collection

  - ### uniqueSet

    public Set<E> uniqueSet()
    Description copied from interface: `Bag`
    Returns a `Set` of unique elements in the Bag.

    Uniqueness constraints are the same as those in `Set`.

    Specified by:
      `uniqueSet` in interface `Bag<E>`
    Returns:
      the Set of unique Bag elements